package cn.com.infosec.math.ec;

import java.math.BigInteger;

class Tnaf {
   private static final BigInteger MINUS_ONE;
   private static final BigInteger MINUS_TWO;
   private static final BigInteger MINUS_THREE;
   public static final byte WIDTH = 4;
   public static final byte POW_2_WIDTH = 16;
   public static final ZTauElement[] alpha0;
   public static final byte[][] alpha0Tnaf;
   public static final ZTauElement[] alpha1;
   public static final byte[][] alpha1Tnaf;

   static {
      BigInteger var0;
      BigInteger var1;
      MINUS_ONE = var1 = (var0 = ECConstants.ONE).negate();
      MINUS_TWO = ECConstants.TWO.negate();
      BigInteger var2;
      MINUS_THREE = var2 = ECConstants.THREE.negate();
      ZTauElement[] var10000 = new ZTauElement[9];
      ZTauElement var3;
      BigInteger var4;
      var3 = new ZTauElement.<init>(var0, var4 = ECConstants.ZERO);
      var10000[1] = var3;
      var3 = new ZTauElement.<init>(var2, var1);
      var10000[3] = var3;
      var3 = new ZTauElement.<init>(var1, var1);
      var10000[5] = var3;
      var3 = new ZTauElement.<init>(var0, var1);
      var10000[7] = var3;
      alpha0 = var10000;
      byte[][] var9 = new byte[8][];
      byte[] var8;
      (var8 = new byte[1])[0] = 1;
      var9[1] = var8;
      byte[] var10004 = var8 = new byte[3];
      var10004[0] = -1;
      var10004[2] = 1;
      var9[3] = var8;
      byte[] var10003 = var8 = new byte[3];
      var10003[0] = 1;
      var10003[2] = 1;
      var9[5] = var8;
      byte[] var10002 = var8 = new byte[4];
      var10002[0] = -1;
      var10002[3] = 1;
      var9[7] = var8;
      alpha0Tnaf = var9;
      var10000 = new ZTauElement[9];
      var3 = new ZTauElement.<init>(var0, var4);
      var10000[1] = var3;
      var3 = new ZTauElement.<init>(var2, var0);
      var10000[3] = var3;
      ZTauElement var7;
      var7 = new ZTauElement.<init>(var1, var0);
      var10000[5] = var7;
      ZTauElement var6;
      var6 = new ZTauElement.<init>(var0, var0);
      var10000[7] = var6;
      alpha1 = var10000;
      var9 = new byte[8][];
      byte[] var5;
      (var5 = new byte[1])[0] = 1;
      var9[1] = var5;
      var10004 = var5 = new byte[3];
      var10004[0] = -1;
      var10004[2] = 1;
      var9[3] = var5;
      var10003 = var5 = new byte[3];
      var10003[0] = 1;
      var10003[2] = 1;
      var9[5] = var5;
      var10002 = var5 = new byte[4];
      var10002[0] = -1;
      var10002[3] = -1;
      var9[7] = var5;
      alpha1Tnaf = var9;
   }

   public static BigInteger norm(byte mu, ZTauElement lambda) {
      ZTauElement var10001 = lambda;
      BigInteger var10003 = lambda.u;
      BigInteger var2 = var10003.multiply(var10003);
      BigInteger lambda1 = lambda.u.multiply(lambda.v);
      BigInteger var5 = var10001.v;
      BigInteger var3 = var5.multiply(var5).shiftLeft(1);
      BigInteger var10000;
      if (mu == 1) {
         var10000 = var2.add(lambda1).add(var3);
      } else {
         if (mu != -1) {
            throw new IllegalArgumentException("mu must be 1 or -1");
         }

         var10000 = var2.subtract(lambda1).add(var3);
      }

      return var10000;
   }

   public static SimpleBigDecimal norm(byte mu, SimpleBigDecimal u, SimpleBigDecimal v) {
      SimpleBigDecimal var10001 = v;
      SimpleBigDecimal var10002 = v;
      SimpleBigDecimal var10003 = u;
      u = u.multiply(u);
      v = var10003.multiply(v);
      SimpleBigDecimal var3 = var10001.multiply(var10002).shiftLeft(1);
      SimpleBigDecimal var10000;
      if (mu == 1) {
         var10000 = u.add(v).add(var3);
      } else {
         if (mu != -1) {
            throw new IllegalArgumentException("mu must be 1 or -1");
         }

         var10000 = u.subtract(v).add(var3);
      }

      return var10000;
   }

   public static ZTauElement round(SimpleBigDecimal lambda0, SimpleBigDecimal lambda1, byte mu) {
      int var3 = lambda0.getScale();
      if (lambda1.getScale() != var3) {
         throw new IllegalArgumentException("lambda0 and lambda1 do not have same scale");
      } else if (mu != 1 && mu != -1) {
         throw new IllegalArgumentException("mu must be 1 or -1");
      } else {
         SimpleBigDecimal var10001 = lambda0;
         BigInteger lambda01 = lambda0.round();
         BigInteger var10 = lambda1.round();
         SimpleBigDecimal var4;
         var10001 = var4 = var10001.subtract(lambda01);
         lambda1 = lambda1.subtract(var10);
         SimpleBigDecimal var5 = var10001.add(var4);
         if (mu == 1) {
            var5 = var5.add(lambda1);
         } else {
            var5 = var5.subtract(lambda1);
         }

         SimpleBigDecimal var6;
         lambda1 = (var6 = lambda1.add(lambda1).add(lambda1)).add(lambda1);
         SimpleBigDecimal var10000;
         if (mu == 1) {
            var10000 = var4;
            var4 = var4.subtract(var6);
            lambda1 = var10000.add(lambda1);
         } else {
            var10000 = var4;
            var4 = var4.add(var6);
            lambda1 = var10000.subtract(lambda1);
         }

         byte var7;
         BigInteger var8;
         byte var12;
         label44: {
            var12 = 0;
            var7 = 0;
            if (var5.compareTo(var8 = ECConstants.ONE) >= 0) {
               if (var4.compareTo(MINUS_ONE) >= 0) {
                  var12 = 1;
                  break label44;
               }
            } else if (lambda1.compareTo(ECConstants.TWO) < 0) {
               break label44;
            }

            var7 = mu;
         }

         label38: {
            if (var5.compareTo(MINUS_ONE) < 0) {
               if (var4.compareTo(var8) < 0) {
                  var12 = -1;
                  break label38;
               }
            } else if (lambda1.compareTo(MINUS_TWO) >= 0) {
               break label38;
            }

            var7 = (byte)(-mu);
         }

         lambda01 = lambda01.add(BigInteger.valueOf((long)var12));
         BigInteger lambda11 = var10.add(BigInteger.valueOf((long)var7));
         return new ZTauElement(lambda01, lambda11);
      }
   }

   public static SimpleBigDecimal approximateDivisionByN(BigInteger k, BigInteger s, BigInteger vm, byte a, int m, int c) {
      int k1;
      BigInteger var10000 = s.multiply(k.shiftRight(m - (k1 = (m + 5) / 2 + c) - 2 + a));
      var10000 = s = var10000.add(vm.multiply(var10000.shiftRight(m)));
      int var10001 = k1 - c;
      k = s.shiftRight(k1 - c);
      if (var10000.testBit(var10001 - 1)) {
         k = k.add(ECConstants.ONE);
      }

      return new SimpleBigDecimal(k, c);
   }

   public static byte[] tauAdicNaf(byte mu, ZTauElement lambda) {
      if (mu != 1 && mu != -1) {
         throw new IllegalArgumentException("mu must be 1 or -1");
      } else {
         int var2;
         byte[] var9 = new byte[(var2 = norm((byte)mu, lambda).bitLength()) > 30 ? var2 + 4 : 34];
         int lambda1 = 0;
         int var3 = 0;
         BigInteger var4 = lambda.u;

         BigInteger var6;
         BigInteger var12;
         for(BigInteger var5 = lambda.v; !var4.equals(var6 = ECConstants.ZERO) || !var5.equals(var6); var4 = var12) {
            BigInteger var10;
            int var11;
            if (var4.testBit(0)) {
               var9[lambda1] = (byte)ECConstants.TWO.subtract(var4.subtract(var5.shiftLeft(1)).mod(ECConstants.FOUR)).intValue();
               if (var9[lambda1] == 1) {
                  var10 = var4.clearBit(0);
               } else {
                  var10 = var4.add(ECConstants.ONE);
               }

               var11 = lambda1;
            } else {
               var9[lambda1] = 0;
               var11 = var3;
               var10 = var4;
            }

            var6 = var10.shiftRight(1);
            if (mu == 1) {
               var5 = var5.add(var6);
            } else {
               var5 = var5.subtract(var6);
            }

            var10 = var10.shiftRight(1).negate();
            ++lambda1;
            var12 = var5;
            var3 = var11;
            var5 = var10;
         }

         byte[] lambda2;
         byte[] var13 = lambda2 = new byte[mu = var3 + 1];
         System.arraycopy(var9, 0, lambda2, 0, mu);
         return var13;
      }
   }

   public static ECPoint.F2m tau(ECPoint.F2m p) {
      if (p.isInfinity()) {
         return p;
      } else {
         ECFieldElement var1 = p.getX();
         ECFieldElement var2 = p.getY();
         ECPoint.F2m var10002 = p;
         ECCurve p1 = p.getCurve();
         var1 = var1.square();
         var2 = var2.square();
         boolean var3 = var10002.isCompressed();
         return new ECPoint.F2m(p1, var1, var2, var3);
      }
   }

   public static byte getMu(ECCurve.F2m curve) {
      byte var10000;
      BigInteger curve1;
      if ((curve1 = curve.getA().toBigInteger()).equals(ECConstants.ZERO)) {
         var10000 = -1;
      } else {
         if (!curve1.equals(ECConstants.ONE)) {
            throw new IllegalArgumentException("No Koblitz curve (ABC), TNAF multiplication not possible");
         }

         var10000 = 1;
      }

      return var10000;
   }

   public static BigInteger[] getLucas(byte mu, int k, boolean doV) {
      if (mu != 1 && mu != -1) {
         throw new IllegalArgumentException("mu must be 1 or -1");
      } else {
         BigInteger var3;
         BigInteger doV1;
         if (doV) {
            doV1 = ECConstants.TWO;
            var3 = BigInteger.valueOf((long)mu);
         } else {
            doV1 = ECConstants.ZERO;
            var3 = ECConstants.ONE;
         }

         BigInteger var10000;
         for(int var4 = 1; var4 < k; doV1 = var10000) {
            BigInteger var5;
            if (mu == 1) {
               var5 = var3;
            } else {
               var5 = var3.negate();
            }

            doV1 = var5.subtract(doV1.shiftLeft(1));
            ++var4;
            var10000 = var3;
            var3 = doV1;
         }

         return new BigInteger[]{doV1, var3};
      }
   }

   public static BigInteger getTw(byte mu, int w) {
      if (w == 4) {
         return mu == 1 ? BigInteger.valueOf(6L) : BigInteger.valueOf(10L);
      } else {
         BigInteger[] mu1;
         BigInteger[] var10000 = mu1 = getLucas(mu, w, false);
         BigInteger w1 = ECConstants.ZERO.setBit(w);
         return ECConstants.TWO.multiply(mu1[0]).multiply(var10000[1].modInverse(w1)).mod(w1);
      }
   }

   public static BigInteger[] getSi(ECCurve.F2m curve) {
      if (curve.isKoblitz()) {
         int var1 = curve.getM();
         int var2 = curve.getA().toBigInteger().intValue();
         byte var3;
         byte var10000 = var3 = curve.getMu();
         int curve1 = curve.getH().intValue();
         BigInteger[] var5 = getLucas(var10000, var1 + 3 - var2, false);
         BigInteger[] var10001;
         BigInteger var6;
         BigInteger var7;
         BigInteger var9;
         if (var10000 == 1) {
            var9 = ECConstants.ONE;
            var10001 = var5;
            var6 = var9.subtract(var5[1]);
            var7 = var9.subtract(var10001[0]);
         } else {
            if (var3 != -1) {
               throw new IllegalArgumentException("mu must be 1 or -1");
            }

            var9 = ECConstants.ONE;
            var10001 = var5;
            var6 = var9.add(var5[1]);
            var7 = var9.add(var10001[0]);
         }

         BigInteger[] var8 = new BigInteger[2];
         if (curve1 == 2) {
            var8[0] = var6.shiftRight(1);
            var8[1] = var7.shiftRight(1).negate();
         } else {
            if (curve1 != 4) {
               throw new IllegalArgumentException("h (Cofactor) must be 2 or 4");
            }

            var8[0] = var6.shiftRight(2);
            var8[1] = var7.shiftRight(2).negate();
         }

         return var8;
      } else {
         throw new IllegalArgumentException("si is defined for Koblitz curves only");
      }
   }

   public static ZTauElement partModReduction(BigInteger k, int m, byte a, BigInteger[] s, byte mu, byte c) {
      BigInteger var6;
      if (mu == 1) {
         var6 = s[0].add(s[1]);
      } else {
         var6 = s[0].subtract(s[1]);
      }

      BigInteger var10002 = var6;
      var6 = getLucas(mu, m, true)[1];
      ZTauElement k1;
      BigInteger m1 = k.subtract(var10002.multiply((k1 = round(approximateDivisionByN(k, s[0], var6, a, m, c), approximateDivisionByN(k, s[1], var6, a, m, c), mu)).u)).subtract(BigInteger.valueOf(2L).multiply(s[1]).multiply(k1.v));
      k = s[1].multiply(k1.u).subtract(s[0].multiply(k1.v));
      return new ZTauElement(m1, k);
   }

   public static ECPoint.F2m multiplyRTnaf(ECPoint.F2m p, BigInteger k) {
      ECPoint.F2m var10000 = p;
      BigInteger var10001 = k;
      ECCurve.F2m var10002 = (ECCurve.F2m)p.getCurve();
      int p1 = var10002.getM();
      byte k1 = (byte)var10002.getA().toBigInteger().intValue();
      byte var2 = var10002.getMu();
      BigInteger[] var3 = var10002.getSi();
      return multiplyTnaf(var10000, partModReduction(var10001, p1, k1, var3, var2, (byte)10));
   }

   public static ECPoint.F2m multiplyTnaf(ECPoint.F2m p, ZTauElement lambda) {
      return multiplyFromTnaf(p, tauAdicNaf(((ECCurve.F2m)p.getCurve()).getMu(), lambda));
   }

   public static ECPoint.F2m multiplyFromTnaf(ECPoint.F2m p, byte[] u) {
      ECPoint.F2m var2 = (ECPoint.F2m)((ECCurve.F2m)p.getCurve()).getInfinity();

      for(int var3 = u.length - 1; var3 >= 0; --var3) {
         var2 = tau(var2);
         if (u[var3] == 1) {
            var2 = var2.addSimple(p);
         } else if (u[var3] == -1) {
            var2 = var2.subtractSimple(p);
         }
      }

      return var2;
   }

   public static byte[] tauAdicWNaf(byte mu, ZTauElement lambda, byte width, BigInteger pow2w, BigInteger tw, ZTauElement[] alpha) {
      if (mu != 1 && mu != -1) {
         throw new IllegalArgumentException("mu must be 1 or -1");
      } else {
         int var6;
         byte[] width1 = new byte[(var6 = norm(mu, lambda).bitLength()) > 30 ? var6 + 4 + width : width + 34];
         BigInteger lambda1 = pow2w.shiftRight(1);
         BigInteger var13 = lambda.u;
         BigInteger var7 = lambda.v;

         BigInteger var9;
         BigInteger var15;
         for(int var8 = 0; !var13.equals(var9 = ECConstants.ZERO) || !var7.equals(var9); var13 = var15) {
            if (var13.testBit(0)) {
               byte var14;
               if ((var9 = var13.add(var7.multiply(tw)).mod(pow2w)).compareTo(lambda1) >= 0) {
                  var14 = (byte)var9.subtract(pow2w).intValue();
               } else {
                  var14 = (byte)var9.intValue();
               }

               width1[var8] = var14;
               boolean var10 = true;
               if (var14 < 0) {
                  var10 = false;
                  var14 = (byte)(-var14);
               }

               if (var10) {
                  var13 = var13.subtract(alpha[var14].u);
                  var7 = var7.subtract(alpha[var14].v);
               } else {
                  var13 = var13.add(alpha[var14].u);
                  var7 = var7.add(alpha[var14].v);
               }
            } else {
               width1[var8] = 0;
            }

            if (mu == 1) {
               var7 = var7.add(var13.shiftRight(1));
            } else {
               var7 = var7.subtract(var13.shiftRight(1));
            }

            var13 = var13.shiftRight(1).negate();
            ++var8;
            var15 = var7;
            var7 = var13;
         }

         return width1;
      }
   }

   public static ECPoint.F2m[] getPreComp(ECPoint.F2m p, byte a) {
      byte var10000 = a;
      ECPoint.F2m[] a1;
      (a1 = new ECPoint.F2m[16])[1] = p;
      byte[][] var2;
      if (var10000 == 0) {
         var2 = alpha0Tnaf;
      } else {
         var2 = alpha1Tnaf;
      }

      int var3 = var2.length;

      for(int var4 = 3; var4 < var3; var4 += 2) {
         a1[var4] = multiplyFromTnaf(p, var2[var4]);
      }

      return a1;
   }
}
